/*---------------------------------------------------------------------------
 *
 *      Title:          Farsi Text Editor - Definitions
 *
 *      File:           farsi.h
 *
 *      Date:           May 1995
 *
 *      Description:
 *           This module is responsible for handling command line input
 *      given key inputs
 *
 *      Rev     By              Description                            Date
 *      1.0     R.J.Harrison    Implement                              9-5-95
 *
 *      Copyright  1995 Zaretto Ltd.
 *---------------------------------------------------------------------------*/

typedef enum
{
    ET_SA, ET_END
}
EXCEPTION_TYPE;

typedef enum
{
    CT_STAND, CT_BEG, CT_MID, CT_END
}
CHAR_TYPE;

#define SPACE         32
#define CHARSET_SIZE 256

#define MAXLEN        40 
#define PAGELEN       23

/*
 * Access method for window specific data
 */
#define TEXT_PAGE_PTR(rw)     ((RESOURCE_WINDOW*)rw)->ptr
#define CURSOR_OFFSET_PTR(rw) ((RESOURCE_WINDOW*)rw)->ptr1
#define CHARTYPE_PTR(rw)      ((RESOURCE_WINDOW*)rw)->ptr2

/*
 * Exceptions to the normal rules
 */
typedef struct
{
    int            code;
    EXCEPTION_TYPE et;
}
EXCEPTION;

/*
 * This translation table defines the key pressed, 
 * which standalone code it generates together with the
 * beginning, middle and end characters
 */
typedef struct
{
    int            stand, beg, mid, end;
    int            tail_stand, tail_beg, tail_mid, tail_end;
}
TRAN_TABLE;

/*
 * Define the structure used to store a page of information.
 */
typedef struct
{
    int            page_number, num_lines;
    char           text[PAGELEN][MAXLEN+10];
    int            modified;
}
TEXT_PAGE;

