#ifndef __PREFS_INCLUDE
#define __PREFS_INCLUDE

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

typedef struct
{
    char *name;
    TY_int size;
    void *data;
    TY_int temporary;
} PREFERENCE_ENTRY;

typedef struct
{
    PREFERENCE_ENTRY *pe;
    void *original;
    void (*set_default) (void*);
}GENERIC_PREF;

typedef struct PREFERENCE_LIST
{
    PREFERENCE_ENTRY *data;
    struct PREFERENCE_LIST *next;
} PREFERENCE_LIST;


typedef struct PREFERENCES
{
    char valid;
    char name[60];
    PREFERENCE_LIST *pref_list;
    char changed;
}
PREFERENCES;

extern PREFERENCES *PR_get_prefs ();

typedef struct
{
    TY_int version, flags;
} PREFS_HDR;

/*
 * Standard ZPL preference structures...
 */
typedef struct
{
    char name[60];
    TY_int depth, width, height;
    TY_int display_id;		/*
				 * WB 2+ 
				 */
    TY_int use_custom_screen, lace, hires;	/*
						 * WB 1.3 
						 */
    TY_int wb_version;
    TY_int use_public_screen;
    char public_screen_to_use[40];
}
SCREEN_PREFS;

typedef struct
{
    PREFS_HDR hdr;
    TY_int memory_usage, memory_amount,
           caching, granularity, 
           error_notification, batch_scroll, use_more_prompt,
           add_formfeed,
           right_margin, ask_before_quit, do_dynamic_updates;

    TEXT_FONT re_font, fw_font, win_font;
    TY_int    scrollback_size, scrollback_remove, title_bar_usage;
    char default_path[200], printer_device[100];
}
GENERAL_PREFS;

typedef struct
{
    PREFS_HDR hdr;
    TY_int prompt, foreground, background, header, body, 
           error, severe_error, interesting;
}COLOUR_PREFS;

#define MESSAGE_HEADER 1
#define MESSAGE_HEADER_INTERESTING 6
#define MESSAGE_BODY 2
#define PARSE_COLOUR 1
#define MESSAGE_BODY_VAIN 3
#define FOREGROUND_COLOUR 4
#define ERROR_COLOUR 5

#ifndef IGNORE_PROTOS
#include "prefs_db.p"
#include "prefs.p"
#endif

#endif
