
#include "win.h"

#define RE_gt_mx 	1
#define RE_gt_cycle 	2
#define RE_gt_box 	3
#define RE_gt_button 	4
#define RE_gt_numeric 	5
#define RE_gt_string 	6
#define RE_gt_lv 	7
#define RE_gt_sb 	8

#define MD_FIRST_MENU 10000

#define RE_scroll_lv_id 31
/*
 * Macros for scaling coordinates
 * All the coordinates given in the resource file
 * are in relative font positions (character cell).
 */
#define FACTOR_Y 1
#define FACTOR_X 1

#define SCFX(a) (((a)*FontX)/FACTOR_X)+x_offset
#define SCFY(a) (((a)*FontY)/FACTOR_Y)+y_offset
#define SCFX_rel(a) (((a)*FontX)/FACTOR_X)
#define SCFY_rel(a) (((a)*FontY)/FACTOR_Y)

#define SCFY_offset_init y_offset = 4;
#define SCFX_offset_init x_offset = 0;

#define SCFY_offset(num_items) y_offset += num_items * FontY - num_items * FACTOR_Y
#define SCFX_offset(num_items) x_offset += num_items * FontX - num_items * FACTOR_X

#define SCset(xs,ys) FontX = max((xs),8); FontY = max((ys),8)
#define SC_reset_offsets y_offset=x_offset=0;y_offset = SCFY (1) + 8;

/*
 * The main resource structure. This will be returned by 'RE_create_resource'
 */
typedef struct RE_resource
{
    char *name;
    struct RE_resource *next;
    struct RE_resource_entry *first_resource;
    struct Gadget *G_list;
    struct TextAttr *textattr;
    struct TextFont *font;	/*
				 * Font to use 
				 */
    TY_int max_x, max_y;
#ifdef AMIGA
    APTR vi;
    APTR gl, ri;		/*
				 * For intuisup (GadgetList / RenderInfo) 
				 */
    struct Window *win;
    struct Screen *scr;
    struct Gadget *last_g;
    struct GadgetData *gadgets;
#endif
#ifdef WINDOWS
    HINSTANCE instance;
    HWND win;
    HWND last_g;
#endif
#ifdef MOTIF
/*    void *win;  /* Parent widget */
#endif
    ZPL_WINDOW *window;
} RE_resource;

/*
 * Resource entry. This is an individual 'gadget', together with the
 * data item. The data item is in dynamic memory, this reference being the
 * address. The address may be copied, and is expected to be copied, for use in
 * an 'update_list'
 */
typedef struct RE_resource_entry
{
    char *name;
#ifdef AMIGA
    struct Gadget *g;
#endif
#ifdef VMS
    void *g;
#endif
#ifdef WINDOWS
    HWND g;
#endif
    BYTE update_in_progress;
    void *read, *write, *last_value;
    void (*process) (struct RE_resource_entry *, void *);
    void *process_param;
    BYTE redisplay;
    TY_int type, id, item_size;
    struct RE_resource_entry *next;
    RE_resource *root;
    char key_shortcut;
    TY_int size, cur_pos, num_lines, num_columns;	/*
							 * For Listviews 
							 */
    TY_int vertical;
    TY_int input_in_progress;
}
RE_resource_entry;

typedef struct
{
    struct NewGadget *ng;
#ifdef AMIGA
    struct Gadget *g;
#endif
#ifdef WINDOWS
    HWND g;
    HINSTANCE instance;
#endif
#ifdef VMS
void *g;
#endif
    char *resource_id;
    void *ptr;
    TY_int size, type;
    char key_shortcut;
    TY_int num_lines, num_columns, vertical;
    ZPL_WINDOW *window;
    USHORT id;
    RE_resource *root;
}
RE_new_gadget;


typedef struct
{
    struct List list;
    char *file_data, *file_data_end;
    struct Node *nodes;
    TY_int lines, size;
}

FILE_LIST;

extern TY_int x_offset, y_offset, FontX, FontY;
extern TY_int re_debug;

#ifndef IGNORE_PROTOS
#include "re_proto.h"
#endif

