typedef struct
{
    char init;
    TY_int size, elem_size, max_size, gran;
    void *ptr;
    char changed;
}
QDB_GRAN_ITEM;

/*
 * Non-amiga types definition
 */


#ifndef N_TYPES_H
#define N_TYPES_H

typedef struct TEXT_FONT
{
    char name[40];
    unsigned short y_size;
    unsigned char style, flags;
}
TEXT_FONT;

#ifndef AMIGA

#define GLOBAL  extern          /*
				 * the declaratory use of an external 
				 */
#define IMPORT  extern          /*
				 * reference to an external 
				 */
#define STATIC  static          /*
				 * a local static variable 
				 */
#define REGISTER register       /*
				 * a (hopefully) register variable 
				 */


#ifndef WIN32
#ifndef VOID
#define VOID            void
#endif
#endif

typedef void *APTR;             /*
				 * 32-bit untyped pointer 
				 */

#ifndef WINDOWS
typedef long LONG;              /*
				 * signed 32-bit quantity 
				 */
typedef unsigned long LONGBITS; /*
				 * 32 bits manipulated individually 
				 */
typedef short WORD;             /*
				 * signed 16-bit quantity 
				 */
typedef unsigned short WORDBITS;        /*
					 * 16 bits manipulated individually 
					 */
typedef short BOOL;
#if __STDC__
typedef signed char BYTE;       /*
				 * signed 8-bit quantity 
				 */
#else
typedef char BYTE;              /*
				 * signed 8-bit quantity 
				 */
#endif
#endif

typedef unsigned short UWORD;   /*
				 * unsigned 16-bit quantity 
				 */
typedef unsigned long ULONG;    /*
				 * unsigned 32-bit quantity 
				 */
typedef ULONG CPTR;


typedef unsigned char UBYTE;    /*
				 * unsigned 8-bit quantity 
				 */
typedef unsigned char BYTEBITS; /*
				 * 8 bits manipulated individually 
				 */
typedef unsigned short RPTR;    /*
				 * signed relative pointer 
				 */
typedef unsigned char *STRPTR;  /*
				 * string pointer (NULL terminated) 
				 */


/*
 * For compatibility only: (don't use in new code) 
 */
typedef short SHORT;            /*
				 * signed 16-bit quantity (use WORD) 
				 */
typedef unsigned short USHORT;  /*
				 * unsigned 16-bit quantity (use UWORD) 
				 */
typedef short COUNT;
typedef unsigned short UCOUNT;


/*
 * Types with specific semantics 
 */
typedef float FLOAT;
typedef double DOUBLE;
typedef unsigned char TEXT;

#ifndef TRUE
#define TRUE            1
#endif
#ifndef FALSE
#define FALSE           0
#endif
#ifndef NULL
#define NULL            0
#endif


#define BYTEMASK        0xFF


/*
 * Lists 
 */
/*
 *  List Node Structure.  Each member in a list starts with a Node
 */

struct Node
{
    struct Node *ln_Succ;       /*
				 * Pointer to next (successor) 
				 */
    struct Node *ln_Pred;       /*
				 * Pointer to previous (predecessor) 
				 */
    char *ln_Name;              /*
				 * ID string, null terminated 
				 */
};                              /*
				 * Note: word aligned 
				 */

/*
 * minimal node -- no type checking possible 
 */
struct MinNode
{
    struct MinNode *mln_Succ;
    struct MinNode *mln_Pred;
};



/*
 * ** Note: Newly initialized IORequests, and software interrupt structures
 * ** used with Cause(), should have type NT_UNKNOWN.  The OS will assign a type
 * ** when they are first used.
 */
/*----- Node Types for LN_TYPE -----*/
#define NT_UNKNOWN      0
#define NT_TASK         1       /*
				 * Exec task 
				 */
#define NT_INTERRUPT    2
#define NT_DEVICE       3
#define NT_MSGPORT      4
#define NT_MESSAGE      5       /*
				 * Indicates message currently pending 
				 */
#define NT_FREEMSG      6
#define NT_REPLYMSG     7       /*
				 * Message has been replied 
				 */
#define NT_RESOURCE     8
#define NT_LIBRARY      9
#define NT_MEMORY       10
#define NT_SOFTINT      11      /*
				 * Internal flag used by SoftInits 
				 */
#define NT_FONT         12
#define NT_PROCESS      13      /*
				 * AmigaDOS Process 
				 */
#define NT_SEMAPHORE    14
#define NT_SIGNALSEM    15      /*
				 * signal semaphores 
				 */
#define NT_BOOTNODE     16
#define NT_KICKMEM      17
#define NT_GRAPHICS     18
#define NT_DEATHMESSAGE 19

#define NT_USER         254     /*
				 * User node types work down from here 
				 */
#define NT_EXTENDED     255

/*
 *  Full featured list header.
 */
struct List
{
    struct Node *lh_Head;
    struct Node *lh_Tail;
    struct Node *lh_TailPred;
    UBYTE lh_Type;
    UBYTE l_pad;
};                              /*

				 * word aligned 
				 */


/*
 *    Check for the presence of any nodes on the given list.  These
 *      macros are even safe to use on lists that are modified by other
 *      tasks.  However; if something is simultaneously changing the
 *      list, the result of the test is unpredictable.
 *
 *      Unless you first arbitrated for ownership of the list, you can't
 *      _depend_ on the contents of the list.  Nodes might have been added
 *      or removed during or after the macro executes.
 *
 *              if( IsListEmpty(list) )         printf("List is empty\n");
 */
#define IsListEmpty(x) \
	( ((x)->lh_TailPred) == (struct Node *)(x) )

#define IsMsgPortEmpty(x) \
	( ((x)->mp_MsgList.lh_TailPred) == (struct Node *)(&(x)->mp_MsgList) )


#ifdef AMIGA
/*
 * ======================================================================== 
 */
/*
 * === MenuItem =========================================================== 
 */
/*
 * ======================================================================== 
 */
struct MenuItem
{
    struct MenuItem *NextItem;  /*
				 * pointer to next in chained list 
				 */
    WORD LeftEdge, TopEdge;     /*
				 * position of the select box 
				 */
    WORD Width, Height;         /*
				 * dimensions of the select box 
				 */
    UWORD Flags;                /*
				 * see the defines below 
				 */

    LONG MutualExclude;         /*
				 * set bits mean this item excludes that 
				 */

    APTR ItemFill;              /*
				 * points to Image, IntuiText, or NULL 
				 */

    /*
     * when this item is pointed to by the cursor and the items highlight
     * *        mode HIGHIMAGE is selected, this alternate image will be displayed
     */
    APTR SelectFill;            /*
				 * points to Image, IntuiText, or NULL 
				 */

    BYTE Command;               /*
				 * only if appliprog sets the COMMSEQ flag 
				 */

    struct MenuItem *SubItem;   /*
				 * if non-zero, points to MenuItem for submenu 
				 */

    /*
     * The NextSelect field represents the menu number of next selected
     * *        item (when user has drag-selected several items)
     */
    UWORD NextSelect;
};

#endif

struct TextAttr
{
    char *ta_Name;              /*
				 * name of the font 
				 */
    long ta_YSize;              /*
				 * height of the font 
				 */
    long ta_Style;              /*
				 * intrinsic font style 
				 */
    long ta_Flags;              /*
				 * font preferences and flags 
				 */
};

/*
 * FLAGS SET BY THE APPLIPROG 
 */
#define CHECKIT         0x0001  /*
				 * set to indicate checkmarkable item 
				 */
#define ITEMTEXT        0x0002  /*
				 * set if textual, clear if graphical item 
				 */
#define COMMSEQ         0x0004  /*
				 * set if there's an command sequence 
				 */
#define MENUTOGGLE      0x0008  /*
				 * set for toggling checks (else mut. exclude) 
				 */
#define ITEMENABLED     0x0010  /*
				 * set if this item is enabled 
				 */

#define MENUENABLED 0x0001      /*
				 * whether or not this menu is enabled 
				 */
#define CHECKED 0x0100          /*
				 * state of the checkmark 
				 */


#define IDCMP_SIZEVERIFY        0x00000001
#define IDCMP_NEWSIZE           0x00000002
#define IDCMP_REFRESHWINDOW     0x00000004
#define IDCMP_MOUSEBUTTONS      0x00000008
#define IDCMP_MOUSEMOVE         0x00000010
#define IDCMP_GADGETDOWN        0x00000020
#define IDCMP_GADGETUP          0x00000040
#define IDCMP_REQSET            0x00000080
#define IDCMP_MENUPICK          0x00000100
#define IDCMP_CLOSEWINDOW       0x00000200
#define IDCMP_RAWKEY            0x00000400
#define IDCMP_REQVERIFY         0x00000800
#define IDCMP_REQCLEAR          0x00001000
#define IDCMP_MENUVERIFY        0x00002000
#define IDCMP_NEWPREFS          0x00004000
#define IDCMP_DISKINSERTED      0x00008000
#define IDCMP_DISKREMOVED       0x00010000
#define IDCMP_WBENCHMESSAGE     0x00020000      /*
						 * System use only                
						 */
#define IDCMP_ACTIVEWINDOW      0x00040000
#define IDCMP_INACTIVEWINDOW    0x00080000
#define IDCMP_DELTAMOVE         0x00100000
#define IDCMP_VANILLAKEY        0x00200000
#define IDCMP_INTUITICKS        0x00400000
/*
 * for notifications from "boopsi" gadgets      
 */
#define IDCMP_IDCMPUPDATE       0x00800000      /*
						 * new for V36    
						 */
/*
 * for getting help key report during menu session      
 */
#define IDCMP_MENUHELP          0x01000000      /*
						 * new for V36    
						 */
/*
 * for notification of any move/size/zoom/change window         
 */
#define IDCMP_CHANGEWINDOW      0x02000000      /*
						 * new for V36    
						 */
#define IDCMP_GADGETHELP        0x04000000      /*
						 * new for V39    
						 */

/*
 * Generic NewGadget used by several of the gadget classes: 
 */

struct NewGadget
{
    long ng_LeftEdge, ng_TopEdge;       /*
					 * gadget position 
					 */
    long ng_Width, ng_Height;   /*
				 * gadget size 
				 */
    char *ng_GadgetText;        /*
				 * gadget label 
				 */
    void *ng_TextAttr;          /*
				 * desired font for gadget label 
				 */
    long ng_GadgetID;           /*
				 * gadget ID 
				 */
    long ng_Flags;              /*
				 * see below 
				 */
    long ng_VisualInfo;         /*
				 * Set to retval of GetVisualInfo() 
				 */
    long ng_UserData;           /*
				 * gadget UserData 
				 */
};


/*
 * ======================================================================== 
 */
/*
 * === NewWindow ========================================================== 
 */
/*
 * ======================================================================== 
 */
struct NewWindow
{
    TY_int LeftEdge, TopEdge;   /*
				 * screen dimensions of window 
				 */
    TY_int Width, Height;       /*
				 * screen dimensions of window 
				 */
    char DetailPen, BlockPen;   /*
				 * for bar/border/gadget rendering 
				 */
    unsigned long IDCMPFlags;   /*
				 * User-selected IDCMP flags 
				 */
    TY_int Flags;               /*
				 * see Window struct for defines 
				 */
    void *FirstGadget;
    void *CheckMark;
    char *Title;                /*
				 * the title text for this window 
				 */
    void *Screen;
    void *BitMap;
    TY_int MinWidth, MinHeight; /*
				 * minimums 
				 */
    unsigned TY_int MaxWidth, MaxHeight;        /*
						 * maximums 
						 */
    unsigned TY_int Type;
};

/*
 * ng_Flags control certain aspects of the gadget.  The first five control
 * * the placement of the descriptive text.  Each gadget kind has its default,
 * * which is usually PLACETEXT_LEFT.  Consult the autodocs for details.
 */
#define PLACETEXT_LEFT  0x0001  /*
				 * Right-align text on left side 
				 */
#define PLACETEXT_RIGHT 0x0002  /*
				 * Left-align text on right side 
				 */
#define PLACETEXT_ABOVE 0x0004  /*
				 * Center text above 
				 */
#define PLACETEXT_BELOW 0x0008  /*
				 * Center text below 
				 */
#define PLACETEXT_IN    0x0010  /*
				 * Center text on 
				 */

#define NG_HIGHLABEL    0x0020  /*
				 * Highlight the label 
				 */

/*
 * The kinds (almost classes) of gadgets that GadTools supports.
 * * Use these identifiers when calling CreateGadgetA()
 */

#define GENERIC_KIND    0
#define BUTTON_KIND     1
#define CHECKBOX_KIND   2
#define INTEGER_KIND    3
#define LISTVIEW_KIND   4
#define MX_KIND         5
#define NUMBER_KIND     6
#define CYCLE_KIND      7
#define PALETTE_KIND    8
#define SCROLLER_KIND   9
/*
 * Kind number 10 is reserved 
 */
#define SLIDER_KIND     11
#define STRING_KIND     12
#define TEXT_KIND       13

#define NUM_KINDS       14

/*
 * The kinds (almost classes) of gadgets that GadTools supports.
 * * Use these identifiers when calling CreateGadgetA()
 */

#define GENERIC_KIND    0
#define BUTTON_KIND     1
#define CHECKBOX_KIND   2
#define INTEGER_KIND    3
#define LISTVIEW_KIND   4
#define MX_KIND         5
#define NUMBER_KIND     6
#define CYCLE_KIND      7
#define PALETTE_KIND    8
#define SCROLLER_KIND   9
/*
 * Kind number 10 is reserved 
 */
#define SLIDER_KIND     11
#define STRING_KIND     12
#define TEXT_KIND       13

#define NUM_KINDS       14

/*------------------------------------------------------------------------*/
/*
 * constants for Tag.ti_Tag, system tag values 
 */
#define TAG_DONE   (0L)         /*
				 * terminates array of TagItems. ti_Data unused 
				 */
#define TAG_END    (0L)         /*
				 * synonym for TAG_DONE                     
				 */
#define TAG_IGNORE (1L)         /*
				 * ignore this item, not end of array               
				 */
#define TAG_MORE   (2L)         /*
				 * ti_Data is pointer to another array of TagItems 
				 */

#define WFLG_SIZEGADGET     0x00000001  /*
					 * include sizing system-gadget? 
					 */
#define WFLG_DRAGBAR        0x00000002  /*
					 * include dragging system-gadget? 
					 */
#define WFLG_DEPTHGADGET    0x00000004  /*
					 * include depth arrangement gadget? 
					 */
#define WFLG_CLOSEGADGET    0x00000008  /*
					 * include close-box system-gadget? 
					 */

#define WFLG_SIZEBRIGHT     0x00000010  /*
					 * size gadget uses right border 
					 */
#define WFLG_SIZEBBOTTOM    0x00000020  /*
					 * size gadget uses bottom border 
					 */
#define WFLG_REFRESHBITS    0x000000C0
#define WFLG_SMART_REFRESH  0x00000000
#define WFLG_SIMPLE_REFRESH 0x00000040
#define WFLG_SUPER_BITMAP   0x00000080
#define WFLG_OTHER_REFRESH  0x000000C0
#define WFLG_BACKDROP       0x00000100  /*
					 * this is a backdrop window 
					 */
#define WFLG_REPORTMOUSE    0x00000200  /*
					 * to hear about every mouse move 
					 */
#define WFLG_GIMMEZEROZERO  0x00000400  /*
					 * a GimmeZeroZero window 
					 */
#define WFLG_BORDERLESS     0x00000800  /*
					 * to get a Window sans border 
					 */
#define WFLG_ACTIVATE       0x00001000  /*
					 * when Window opens, it's Active 
					 */
#define WFLG_RMBTRAP        0x00010000  /*
					 * Catch RMB events for your own 
					 */
#define WFLG_NOCAREREFRESH  0x00020000  /*
					 * not to be bothered with REFRESH 
					 */

/*
 * V34-style IDCMP class names: 
 */

#define SIZEVERIFY      IDCMP_SIZEVERIFY
#define NEWSIZE         IDCMP_NEWSIZE
#define REFRESHWINDOW   IDCMP_REFRESHWINDOW
#define MOUSEBUTTONS    IDCMP_MOUSEBUTTONS
#define MOUSEMOVE       IDCMP_MOUSEMOVE
#define GADGETDOWN      IDCMP_GADGETDOWN
#define GADGETUP        IDCMP_GADGETUP
#define REQSET          IDCMP_REQSET
#define MENUPICK        IDCMP_MENUPICK
#define CLOSEWINDOW     IDCMP_CLOSEWINDOW
#define RAWKEY          IDCMP_RAWKEY
#define REQVERIFY       IDCMP_REQVERIFY
#define REQCLEAR        IDCMP_REQCLEAR
#define MENUVERIFY      IDCMP_MENUVERIFY
#define NEWPREFS        IDCMP_NEWPREFS
#define DISKINSERTED    IDCMP_DISKINSERTED
#define DISKREMOVED     IDCMP_DISKREMOVED
#define WBENCHMESSAGE   IDCMP_WBENCHMESSAGE
#define ACTIVEWINDOW    IDCMP_ACTIVEWINDOW
#define INACTIVEWINDOW  IDCMP_INACTIVEWINDOW
#define DELTAMOVE       IDCMP_DELTAMOVE
#define VANILLAKEY      IDCMP_VANILLAKEY
#define INTUITICKS      IDCMP_INTUITICKS
#define IDCMPUPDATE     IDCMP_IDCMPUPDATE
#define MENUHELP        IDCMP_MENUHELP
#define CHANGEWINDOW    IDCMP_CHANGEWINDOW
#define LONELYMESSAGE   IDCMP_LONELYMESSAGE


/*
 * V34-style Window->Flags names: 
 */

#define WINDOWSIZING    WFLG_SIZEGADGET
#define WINDOWDRAG      WFLG_DRAGBAR
#define WINDOWDEPTH     WFLG_DEPTHGADGET
#define WINDOWCLOSE     WFLG_CLOSEGADGET
#define SIZEBRIGHT      WFLG_SIZEBRIGHT
#define SIZEBBOTTOM     WFLG_SIZEBBOTTOM
#define REFRESHBITS     WFLG_REFRESHBITS
#define SMART_REFRESH   WFLG_SMART_REFRESH
#define SIMPLE_REFRESH  WFLG_SIMPLE_REFRESH
#define SUPER_BITMAP    WFLG_SUPER_BITMAP
#define OTHER_REFRESH   WFLG_OTHER_REFRESH
#define BACKDROP        WFLG_BACKDROP
#define REPORTMOUSE     WFLG_REPORTMOUSE
#define GIMMEZEROZERO   WFLG_GIMMEZEROZERO
#define BORDERLESS      WFLG_BORDERLESS
#define ACTIVATE        WFLG_ACTIVATE
#define WINDOWACTIVE    WFLG_WINDOWACTIVE
#define INREQUEST       WFLG_INREQUEST
#define MENUSTATE       WFLG_MENUSTATE
#define RMBTRAP         WFLG_RMBTRAP
#define NOCAREREFRESH   WFLG_NOCAREREFRESH
#define WINDOWREFRESH   WFLG_WINDOWREFRESH
#define WBENCHWINDOW    WFLG_WBENCHWINDOW
#define WINDOWTICKED    WFLG_WINDOWTICKED
#define NW_EXTENDED     WFLG_NW_EXTENDED
#define VISITOR         WFLG_VISITOR
#define ZOOMED          WFLG_ZOOMED
#define HASZOOM         WFLG_HASZOOM
#define WBENCHSCREEN 0

void NewList (struct List *lis);
struct Node *AddTail (struct List *, struct Node *);
struct Node *RemTail (struct List *lis);
struct Node *RemHead (struct List *lis);
#endif
#endif /*
	* N_TYPES_H 
	*/
