
/*#define LOCAL_XPR*/
/*#define  SET_SERIAL*/

/*#define XPR_DEB*/

#include <exec/types.h>
#include <devices/serial.h>
#include <devices/timer.h>
#include <libraries/dos.h>

#include <proto/dos.h>

#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "OS_def.h"		/*
				 * Os specific definitions 
				 */


#include "win.h"
#include "prefs.h"

#include "xproto.h"

#ifdef LATTICE			/* ~~~~~ Possibly the problem ~~~~~ */
#include <proto/utility.h>
#include <proto/timer.h>
#include <proto/exec.h>
#endif /* LATTICE */

#define SIGBIT_SERIAL (1 << read_port->mp_SigBit)
#define SIGBIT_TIMER (1 << TimeRequest->tr_node.io_Message.mn_ReplyPort->mp_SigBit)

 /* xpr serial bits. */

#define SAVE_DS __saveds __asm
#define LONG long

#ifdef ASDASD
#ifndef LOCAL_XPR
/* For use in comm programs written in Lattice C; allows calling XProtocol
   library functions directly without glue routines. */
#pragma libcall XProtocolBase XProtocolCleanup 1e 801
#pragma libcall XProtocolBase XProtocolSetup 24 801
#pragma libcall XProtocolBase XProtocolSend 2a 801
#pragma libcall XProtocolBase XProtocolReceive 30 801
#pragma libcall XProtocolBase XProtocolHostMon 36 109804
#pragma libcall XProtocolBase XProtocolUserMon 3c 109804
#endif

#ifdef AA_O
#define __a0
#define __a1
#define __a2
#define __a3
#define __a4
#define __a5
#define __a6
#define __a7
#define __d0
#define __d1
#define __d2
#define __d3
#define __d4
#define __d5
#define __d6
#define __d7
#define register
#endif
#endif

#define ST_PARTYON	(1 << 0)
#define ST_PARTYODD	(1 << 1)
#define ST_7WIRE	(1 << 2)
#define ST_QBREAK	(1 << 3)
#define ST_RADBOOGIE	(1 << 4)
#define ST_SHARED	(1 << 5)
#define ST_EOFMODE	(1 << 6)
#define ST_XDISABLED	(1 << 7)
#define ST_PARTYMARKON	(1 << 8)
#define ST_PARTYMARK	(1 << 9)
#define ST_2BITS	(1 << 10)
#define ST_READ7	(1 << 11)
#define ST_WRITE7	(1 << 12)

#define ONE_MILLION 1000000L
#define GET_PERCENT(a,b) ((TY_int)( (a/(float)b)*100.0))

char *xpr_library_name = "xprzmodem.library";
static struct IOExtSer *ser_write, *ser_read;
#include <devices/timer.h>	/* Timer device. */

#define CreateIORequest CreateExtIO

#ifdef EXTERN_TIMER
extern struct timerequest *TimeRequest;
#else
static struct timerequest *TimeRequest;
struct Library *TimerBase;
struct MsgPort *IOPort;
#endif

static struct MsgPort *read_port;
static struct MsgPort *write_port;
struct Library *XProtocolBase;
static struct XPR_IO XprIO_real, *XprIO = &XprIO_real;
static TY_int TransferBits;
FIONA_WINDOW *XPR_fw, *XPR_progress_fw;
static char last_dl_name[200];


void status_line (a, b, c)
char *a, *b, *c;
{
    char aa[300];
    sprintf (aa, a, b, c);
    if (XPR_progress_fw)
	FW_progress_window (XPR_progress_fw->sub_window, NULL, NULL,
			    0, 0, aa);
}

/*
 * These variables keep the transferred bytes and transfer
 * time in seconds.
 */

static long ByteVal, ByteMax, TimeVal, TimeMax;

/*
 * The name of the file being transmitted, in case the
 * `override destination' feature is enabled.
 */

static char RealName[256];

static char OverrideDestination = TRUE;

char *XPR_get_last_dl_file (void)
{
    return (last_dl_name);
}

/* XPR_fopen(UBYTE *filename,UBYTE *AccessMode):
 *
 *	Open a file for random access.
 */

LONG SAVE_DS
  XPR_fopen (register __a0 UBYTE * filename, register __a1 UBYTE * AccessMode)
{
    FILE *file;
    char *c;
    /* Reset transfer counters. */
    ByteVal = ByteMax = TimeVal = TimeMax = 0;

    /* Remember file name. */

    strcpy (RealName, filename);

    if (AccessMode[0] != 'r')
    {
	strcpy (RealName, PR_get_download_path ());

	if (add_part (RealName, file_part (filename), 256))
	    filename = RealName;
    }

/*
 * Remove hard-to-access characters from the filename...
 */
    for (c = filename; *c; c++)
	if (*c == '~')
	    *c = '!';
    /* Determine file transfer mode... */

    if (file = fopen (filename, AccessMode))
    {
	switch (AccessMode[0])
	{
	case 'r':
	    status_line ("Send file \"%s\".", filename);
	    break;

	case 'w':
	    status_line ("Receive file \"%s\".", filename);
	    break;

	case 'a':
	    status_line ("Update file \"%s\".", filename);
	    break;
	}
	strcpy (last_dl_name, filename);
    }
    return ((LONG) file);
}

/* XPR_fclose(FILE *file):
 *
 *	Close a file opened by XPR_fopen.
 */

LONG SAVE_DS
  XPR_fclose (register __a0 FILE * file)
{
    /* Close the file and see what it brings... */

    if (file && fclose (file))
    {
	status_line ("Close file \"%s\".", RealName);
    }
    *RealName = NULL;
    return (1);
}

 /*
  * XPR_fread(APTR Buffer,LONG Size,LONG Count,struct Buffer *file):
  *
  * Read a few bytes from a file.
  */

LONG SAVE_DS
  XPR_fread (register __a0 APTR Buffer, register __d0 LONG Size, register __d1 LONG Count, register __a1 FILE * file)
{
    return (fread (Buffer, Size, Count, file) / Size);
}

 /*
  * XPR_fwrite(APTR Buffer,LONG Size,LONG Count,FILE *file):
  *
  * Write a few bytes to a file.
  */

LONG SAVE_DS
  XPR_fwrite (register __a0 APTR Buffer, register __d0 LONG Size, register __d1 LONG Count, register __a1 FILE * file)
{
    return (fwrite (Buffer, Size, Count, file) / Size);
}

 /*
  * XPR_fseek(FILE *file,LONG Offset,LONG Origin):
  *
  * Move the read/write pointer in a file.
  */

LONG SAVE_DS
  XPR_fseek (register __a0 FILE * file, register __d0 LONG Offset, register __d1 LONG Origin)
{
    return (fseek (file, Offset, Origin) ? 0 : -1);
}

 /*
  * XPR_chkabort():
  *
  * Check if the user has aborted the transfer.
  */

LONG SAVE_DS
  XPR_chkabort ()
{
    if (CM_aborted ())
    {
	status_line ("Transfer aborted.");
	return (-1);
    }
/*1 = status_line ("File skipped.");*/
    return (0);
}

#ifdef SAVE_R_DATA
void save_data (char *p, TY_int s)
{
    static FILE *f = NULL;
    if (p && s)
    {
	if (!f)
	    f = fopen ("t:xpr_data", "w");
	fwrite (p, s, 1, f);
    }
    if (f && !p && !s)
    {
	fclose (f);
	f = NULL;
    }
}
#endif

 /*
  * XPR_sread(UBYTE *Buffer,LONG Size,LONG Timeout):
  *
  * Read a few bytes from the serial port (including timeouts).
  */

ULONG SAVE_DS
  XPR_sread (register __a0 UBYTE * Buffer, register __d0 ULONG Size, register __d1 ULONG Timeout)

{
    /* Valid parameters? */

    if (ser_read && Size)
    {
	TY_int bytes_in_buffer;
	/* How many bytes are still in the serial buffer? */

	ser_read->IOSer.io_Command = SDCMD_QUERY;
	DoIO (ser_read);
	bytes_in_buffer = ser_read->IOSer.io_Actual;

	/*
	 * No timeout specified? Return as many bytes as are currently within
	 * the buffer.
	 */
	if (Timeout)
	{
	    /*
	     * Small enhancement: if the serial buffer holds as many bytes as
	     * we may need, read the data immediately and return as quickly
	     * as possible.
	     */

	    if (bytes_in_buffer >= Size)
	    {
		ser_read->IOSer.io_Command = CMD_READ;
		ser_read->IOSer.io_Data = Buffer;
		ser_read->IOSer.io_Length = Size;

		if (!DoIO (ser_read))
		{
#ifdef XPR_DEB
		    printf ("XPR_nread_full: %d\n", ser_read->IOSer.io_Actual);
#endif
#ifdef SAVE_R_DATA
		    save_data (ser_read->IOSer.io_Data, ser_read->IOSer.io_Actual);
#endif
		    return (ser_read->IOSer.io_Actual);
		}
		else
		{
#ifdef XPR_DEB
		    printf ("XPR_nread_full_er: %d\n", ser_read->IOSer.io_Actual);
#endif
		}
		return (ser_read->IOSer.io_Error ? -1 : ser_read->IOSer.io_Actual);
	    }
	    else
	    {
		register ULONG SignalSet;


		/* Set up the read request. */

		ser_read->IOSer.io_Command = CMD_READ;
		ser_read->IOSer.io_Data = Buffer;
		ser_read->IOSer.io_Length = Size;

		/* Set up the timer. */

		TimeRequest->tr_node.io_Command = TR_ADDREQUEST;
		TimeRequest->tr_time.tv_secs = (Timeout >= ONE_MILLION) ? (Timeout / ONE_MILLION) : 0;
		TimeRequest->tr_time.tv_secs = Timeout / ONE_MILLION;
		TimeRequest->tr_time.tv_micro = Timeout % ONE_MILLION;

		/* Prevent early termination. */
		SetSignal (0, SIGBIT_SERIAL | SIGBIT_TIMER);

		/* Start IO... */

		SendIO (ser_read);
		SendIO (TimeRequest);

		while (TRUE)
		{
		    SignalSet = SIGBIT_SERIAL | SIGBIT_TIMER;
		    SignalSet = Wait (SignalSet);

		    if (!CheckIO (ser_read))
			AbortIO (ser_read);
		    WaitIO (ser_read);

		    if (!CheckIO (TimeRequest))
			AbortIO (TimeRequest);
		    WaitIO (TimeRequest);

#ifdef XPR_DEB
		    printf ("XPR_nr: %d (%d)\n", ser_read->IOSer.io_Actual, Timeout, SignalSet & SIGBIT_TIMER);
#endif
#ifdef SAVE_R_DATA
		    save_data (ser_read->IOSer.io_Data, ser_read->IOSer.io_Actual);
#endif
		    return (ser_read->IOSer.io_Actual);

		}
	    }
	}
	else
	{
	    register ULONG Length;

	    /* Are there any bytes in the buffer? */

	    if (bytes_in_buffer)
	    {

		/*
		 * Ensure that the buffer is only filled rather than overfilled...
		 */

		if (bytes_in_buffer > Size)
		{
		    bytes_in_buffer = Size;
#ifdef XPR_DEB
		    printf ("size limited to %d\n", bytes_in_buffer);
#endif
		}

		/*
                 * Read in the data
                 */
		ser_read->IOSer.io_Command = CMD_READ;
		ser_read->IOSer.io_Data = Buffer;
		ser_read->IOSer.io_Length = bytes_in_buffer;
		DoIO (ser_read);

#ifdef XPR_DEB
		printf ("XPR_nt: %d\n", ser_read->IOSer.io_Actual);
#endif
#ifdef SAVE_R_DATA
		save_data (ser_read->IOSer.io_Data, ser_read->IOSer.io_Actual);
#endif
		return (ser_read->IOSer.io_Actual);
	    }
	}
    }
    return (0);
}

 /*
  * XPR_swrite(UBYTE *Buffer,LONG Size):
  *
  * Write a few bytes to the serial port.
  */

LONG SAVE_DS
  XPR_swrite (register __a0 UBYTE * Buffer, register __d0 LONG Size)
{
#ifdef XPR_DEB
    printf ("XPR_swrite: %d [%8x]\n", Size, *Buffer);
#endif
    if (ser_write)
    {
	ser_write->IOSer.io_Command = CMD_WRITE;
	ser_write->IOSer.io_Data = Buffer;
	ser_write->IOSer.io_Length = Size;
	return ((LONG) DoIO (ser_write));
    }
    else
	return (-1);
}

 /*
  * XPR_sflush():
  *
  * Release the contents of all serial buffers.
  */

LONG SAVE_DS
  XPR_sflush ()
{
    if (ser_read)
    {
	ser_read->IOSer.io_Command = CMD_CLEAR;

	return ((LONG) DoIO (ser_read));
    }
    else
	return (-1);
}


 /*
  * truncate_name(UBYTE *filename):
  *
  * Truncates a file name to a maximum of 48 characters.
  */

static char *__regargs
  truncate_name (UBYTE * filename)
{
    static char namebuffer[256];
    TY_int len = strlen (filename);

    if (len < 48)
	strcpy (namebuffer, filename);
    else
    {
	strcpy (filename, "...");
	strcpy (namebuffer, &filename[len - 40]);
    }
    return (namebuffer);
}


static long convert_time_to_seconds (char *String)
{
    UBYTE Buffer[20];
    LONG Seconds = 0;

    memset (Buffer, 0, 20);
    strcpy (Buffer, String);
    Seconds += atol (&Buffer[6]);
    Buffer[5] = 0;
    Seconds += atol (&Buffer[3]) * 60;
    Buffer[2] = 0;
    Seconds += atol (&Buffer[0]) * 3600;
    return (Seconds);
}

 /*
  * XPR_update(struct XPR_UPDATE *UpdateInfo):
  *
  * Update the information displayed in the transfer window.
  */

static TY_int fsize = 0, rate = 0, NewByte = FALSE;
static char opb1[50], opb2[50], *filename = NULL;

static void init_update_vase ()
{
    filename = fsize = 0, rate = 0, NewByte = FALSE;
    *opb1 = *opb2 = 0;
}

LONG SAVE_DS
  XPR_update (register __a0 struct XPR_UPDATE *UpdateInfo)
{
    TY_int percent_complete = -1;
    char *comment = NULL;

    if (UpdateInfo)
    {
	if ((UpdateInfo->xpru_updatemask & XPRU_BYTES) && UpdateInfo->xpru_bytes != -1)
	{
	    NewByte = UpdateInfo->xpru_bytes;
	}

	if ((UpdateInfo->xpru_updatemask & XPRU_ERRORMSG) && UpdateInfo->xpru_errormsg)
	{
	    comment = UpdateInfo->xpru_errormsg;
#ifdef XPR_DEB
	    printf ("XPR_error: %s\n", comment);
#endif
	}

	if ((UpdateInfo->xpru_updatemask & XPRU_FILENAME) && UpdateInfo->xpru_filename)
	{
	    filename = UpdateInfo->xpru_filename;
	}

	if ((UpdateInfo->xpru_updatemask & XPRU_FILESIZE) && UpdateInfo->xpru_filesize != -1)
	{
	    fsize = UpdateInfo->xpru_filesize;
	}

	if ((UpdateInfo->xpru_updatemask & XPRU_DATARATE) && UpdateInfo->xpru_datarate != -1)
	{
	    rate = UpdateInfo->xpru_datarate;
	}

	if (fsize && NewByte)
	    percent_complete = GET_PERCENT (NewByte, fsize);

	sprintf (opb1, "%4ld CPS%4dk", rate, (NewByte + 500) / 1024);
	sprintf (opb2, "%s (size %s)", file_part (filename), describe_size(fsize));
	if (XPR_progress_fw)
	    FW_progress_window (XPR_progress_fw->sub_window, opb1, opb2,
				0, percent_complete, comment);
    }
    return (1);
}

 /*
  * xpr_setserial(LONG Status):
  *
  * Set/read the serial status (parameters).
  */

LONG SAVE_DS
  XPR_setserial (register __d0 LONG Status)
{
#ifdef SET_SERIAL
    if (ser_read)
    {
	static long XprBauds[12] =
	{
	    110,
	    300,
	    1200,
	    2400,
	    4800,
	    9600,
	    19200,
	    31250,
	    38400,
	    57600,
	    76800,
	    115200
	};

	LONG Return = 0;

	ser_read->IOSer.io_Command = SDCMD_QUERY;

	DoIO (ser_read);

	if (Status != -1)
	{
	    ser_read->IOSer.io_Command = SDCMD_SETPARAMS;

	    ser_read->io_SerFlags = Status & 0xFF;
	    ser_read->io_ExtFlags = 0;

	    if (Status & ST_PARTYMARKON)
		ser_read->io_ExtFlags |= SEXTF_MSPON;

	    if (Status & ST_PARTYMARK)
		ser_read->io_ExtFlags |= SEXTF_MARK;

	    if (Status & ST_2BITS)
		ser_read->io_StopBits = 2;
	    else
		ser_read->io_StopBits = 1;

	    if (Status & ST_READ7)
		ser_read->io_ReadLen = 7;
	    else
		ser_read->io_ReadLen = 8;

	    if (Status & ST_WRITE7)
		ser_read->io_WriteLen = 7;
	    else
		ser_read->io_WriteLen = 8;

	    DoIO (ser_read);

	    ser_write->io_SerFlags = ser_read->io_SerFlags;
	    ser_write->io_ExtFlags = ser_read->io_ExtFlags;

	    ser_write->io_StopBits = ser_read->io_StopBits;
	    ser_write->io_ReadLen = ser_read->io_ReadLen;
	    ser_write->io_WriteLen = ser_read->io_WriteLen;
	}
	return (Return);
    }
    else
#endif
	return (-1);
}


 /*
  * XPR_finfo(UBYTE *filename,LONG InfoType):
  *
  * Return information on a given file.
  */

LONG SAVE_DS
  XPR_finfo (register __a0 UBYTE * filename, register __d0 LONG InfoType)
{
    BPTR FileLock;

    switch (InfoType)
    {
    case 1:
	if (FileLock = Lock (filename, ACCESS_READ))
	{
	    struct FileInfoBlock __aligned FileInfo;
	    register LONG Size;

	    if (Examine (FileLock, &FileInfo))
		Size = FileInfo.fib_Size;
	    else
		Size = 0;

	    UnLock (FileLock);

	    return (Size);
	}

	break;

    case 2:
	return (1);
    }

    return (0);
}


 /*
  * XPR_unlink(UBYTE *filename):
  *
  * Remove (delete) a given file.
  */

LONG SAVE_DS
  XPR_unlink (register __a0 UBYTE * filename)
{
    LONG Success = DeleteFile (filename) ? 0 : -1;

    if (Success)
	status_line ("Delete file \"%s\".", filename);

    return (Success);
}

 /*
  * XPR_squery():
  *
  * Check how many characters are present in the serial buffer.
  */

LONG SAVE_DS
  XPR_squery ()
{
    if (ser_read)
    {
	ser_read->IOSer.io_Command = SDCMD_QUERY;

	if (!DoIO (ser_read))
	    return ((LONG) ser_read->IOSer.io_Actual);
    }

    return (-1);
}

 /*
  * XPR_getptr(LONG InfoType):
  *
  * Return a pointer to the screen.
  */

LONG SAVE_DS
  XPR_getptr (register __d0 LONG InfoType)
{
#ifdef WIERD
    if (InfoType == 1)
	return ((LONG) Screen);
    else
#endif
	return (-1);
}

 /*
  * XPR_stealopts(UBYTE *Prompt,UBYTE *Buffer):
  *
  * Steal the contents of the options buffer (replacement for xpr_gets).
  */

LONG SAVE_DS
  XPR_stealopts (register __a0 UBYTE * Prompt, register __a1 UBYTE * Buffer)
{
#ifdef AASD
    if (Buffer)
	strcpy (xpr_options_buffer, Buffer);
#endif
    return (1);
}


 /* Obtain the protocol default settings. */

static char *get_xpr_options ()
{
    COMMS_PREFS *cp = PR_get_comms_prefs ();
    static char *oa = "YNRS";
    static TY_int bc[] =
    {1, 8, 16, 32, 128, 256, 512, 1024, 2048};
    TY_int buffer, frame = 0;
    char overwrite = oa[cp->overwrite_mode];
    static char xpr_options_buffer[200];

    buffer = bc[cp->buffer_size];
    if (cp->frame_size)
	frame = buffer * 1024;
    sprintf (xpr_options_buffer, "Tn,O%c,B%d,F%d,E%d,An,Dn,Ky,Sn,Rn,P%s",
	     overwrite,
	     buffer,
	     frame,
	     cp->error_count,
	     PR_get_download_path ());
    /*printf ("XPR options %s\n", xpr_options_buffer);*/
    return (xpr_options_buffer);
}

/*
 * This is called from the comms module. It tells us what the data items are
 * to use for interfacing..
 */

TY_int XPR_setup (FIONA_WINDOW * fw, struct IOExtSer *sw, struct IOExtSer *sr,
	       struct MsgPort *wp, struct MsgPort *rp)
{
    extern void a_XPR_fopen (), a_XPR_fclose (), a_XPR_fread (), a_XPR_fwrite (),
      a_XPR_sread (), a_XPR_swrite (), a_XPR_sflush (), a_XPR_update (),
      a_XPR_chkabort (), a_XPR_setserial (), a_XPR_finfo (), a_XPR_fseek (),
      a_XPR_unlink (), a_XPR_squery (), a_XPR_getptr ();

    UBYTE namebuffer[40];
    char *c;


/*
 * Save the device level information.
 * NOTE: Only one xpr may be used at a time...
 */
    ser_write = sw;
    ser_read = sr;
    XPR_fw = fw;
    read_port = rp;
    write_port = wp;

#ifndef LOCAL_XPR
    /* Close the old library if still open. */
    if (XProtocolBase)
    {
	XProtocolCleanup (XprIO);

	CloseLibrary (XProtocolBase);
    }
#endif

    /* Clear the XPR interface buffer. */

    memset (XprIO, 0, sizeof (struct XPR_IO));

    /* Copy the name of the library. */

    strcpy (namebuffer, file_part (xpr_library_name));

    if ((c = strchr (namebuffer, '.')))
	*c = 0;

    /* Initialize the interface structure. */
    XprIO->xpr_filename = get_xpr_options ();
    XprIO->xpr_fopen = (APTR) a_XPR_fopen;
    XprIO->xpr_fclose = (APTR) a_XPR_fclose;
    XprIO->xpr_fread = (APTR) a_XPR_fread;
    XprIO->xpr_fwrite = (APTR) a_XPR_fwrite;
    XprIO->xpr_sread = (APTR) a_XPR_sread;
    XprIO->xpr_swrite = (APTR) a_XPR_swrite;
    XprIO->xpr_sflush = (APTR) a_XPR_sflush;
    XprIO->xpr_update = (APTR) a_XPR_update;
    XprIO->xpr_chkabort = (APTR) a_XPR_chkabort;
#ifdef SET_SERIAL
    XprIO->xpr_setserial = (APTR) a_XPR_setserial;
#else
    XprIO->xpr_setserial = 0;
#endif
    XprIO->xpr_finfo = (APTR) a_XPR_finfo;
    XprIO->xpr_fseek = (APTR) a_XPR_fseek;
    XprIO->xpr_gets = NULL;
    XprIO->xpr_ffirst = NULL;
    XprIO->xpr_fnext = NULL;

    XprIO->xpr_extension = 0;

    /* Try to open the library. */

#ifdef LOCAL_XPR
    if (1)
#else
    if (XProtocolBase = (struct Library *) OpenLibrary (xpr_library_name, 0))
#endif
    {
	/* Set up the library. */

	TransferBits = XProtocolSetup (XprIO);

	/* Successful initialization? */

	if (!(TransferBits & XPRS_SUCCESS))
	{
	    error_log ("Failed to set up protocol %s", xpr_library_name);

#ifndef LOCAL_XPR
	    CloseLibrary (XProtocolBase);
#endif
	    XProtocolBase = NULL;
	    xpr_library_name[0] = 0;
	    TransferBits = 0;
	    return (FALSE);
	}

	if (!(IOPort = CreatePort (NULL, NULL)))
	{
            TimeRequest = NULL;
	    error_log ("Failed to create msgport for time");
	    return (FALSE);
	}

	if (!(TimeRequest = (struct timerequest *) CreateIORequest (IOPort, sizeof (struct timerequest))))
	{
	    DeleteMsgPort (IOPort);
	    error_log ("Failed to create iorequest for timer");
	    return (FALSE);
	}
	if (OpenDevice ("timer.device", UNIT_VBLANK, (struct IORequest *) TimeRequest, 0))
	{
	    error_log ("Failed to open timer.device");
	    return (FALSE);
	}

	TimerBase = (struct Library *) TimeRequest->tr_node.io_Device;
    }
    else
    {
	error_log ("Failed to open protocol %s", xpr_library_name);
	return (0);
    }

    return (TRUE);
}

TY_int XPR_receive ()
{
    init_update_vase ();
    XPR_progress_fw = open_window (make_parse_window ());
    XprIO->xpr_filename = NULL;
    FW_set_title (XPR_progress_fw, "ZMODEM Receive");
    XProtocolReceive (XprIO);
#ifdef SAVE_R_DATA
    save_data (0, 0);
#endif
    close_window (XPR_progress_fw);
    CM_clear_abort ();
    return (TRUE);
}

TY_int XPR_send (char *filename)
{
    init_update_vase ();
    XPR_progress_fw = open_window (make_parse_window ());
    XprIO->xpr_filename = filename;
    FW_set_title (XPR_progress_fw, "ZMODEM Send");
    XProtocolSend (XprIO);
#ifdef SAVE_R_DATA
    save_data (0, 0);
#endif
    close_window (XPR_progress_fw);
    CM_clear_abort ();
    return (TRUE);
}

void XPR_closedown ()
{
    if (TimeRequest)
    {
	if (TimeRequest->tr_node.io_Device)
	    CloseDevice ((struct IORequest *) TimeRequest);

        if(TimeRequest)
	    DeleteExtIO (TimeRequest);

	if (IOPort)
	    DeletePort (IOPort);
    }
    /* Close the old library if still open. */
    if (XProtocolBase)
    {
	XProtocolCleanup (XprIO);

	CloseLibrary (XProtocolBase);
        XProtocolBase = 0;
    }

}
